# -*- coding: utf-8 -*-
from setuphelpers import *
import json


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    if get_os_name() == "Windows":
        api_url = "https://api.github.com/repos/0install/0install-win/releases/latest"
    elif get_os_name() == "Linux":
        api_url = "https://api.github.com/repos/0install/0install/releases/latest"
    else:
        print("You must be on a Windows or Linux OS")

    download_dict = {
        "windows-all": "0install.exe",
        "linux-arm64": "0install-linux-arm",
        "linux-x86": "0install-linux-x86_64",
    }

    # Getting latest version information from official sources
    print("API used is: %s" % api_url)
    json_load = json.loads(wgets(api_url, proxies=proxies))
    for to_download in json_load["assets"]:
        if download_dict[control.target_os + "-" + ensure_list(control.architecture)[0]] in to_download["name"]:
            download_url = to_download["browser_download_url"]
            latest_bin = to_download["name"]
            break

    # Deleting binaries
    for f in glob.glob("*.exe"):
        print("Removing: %s" % f)
        remove_file(f)

    # Downloading latest binaries
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
        package_updated = True
    else:
        print("Binary is present: %s" % latest_bin)

    print("Downloading content for offline install")
    run(f".{os.sep}{latest_bin} --prepare-offline")

    # Checking version from file
    version = get_version_from_binary(latest_bin)

    control.set_software_version(version.split('+')[0])
    control.save_control_to_wapt()

    # Deleting outdated binaries
    remove_outdated_binaries(latest_bin)

    # Validating update-package-sources
    return package_updated
